import java.util.Random;

/**
 * This class implements linear search and binary search.
 * List generation methods are provided.
 * 
 * @author YOUR NAMES HERE
 */
public class ListSearcher
{
    //instance variables
    private int[] list;

    /**
     * Constructs a list searcher with a list of the given size of random integers
     * @param size Length of the list
     */
    public ListSearcher(int size)
    {
        //TODO: Fill me in (and delete this comment!)
        
    }   

    /**
     * This "shuffles" the elements around in the list.
     * Like shuffling a deck of cards
     */
    public void shuffle()
    {
        Random randGen = new Random(); //a random number generator for you to use

        //TODO: Fill me in (and delete this comment!)

        //for each element, list[i] in the loop,
        //   generate a random index j with a range from i (inclusive) to list.length-1 (not inclusive)
        //   swap list[i] with list[j]
    }

    /**
     * Performs a linear search of the list for the target
     * @param the target to look for in the list
     * @return index of first occurrence of target, or -1 if not found
     */
    public int linearSearch(int target)
    {
        for(int i=0; i<list.length; i++) //go through the list
        {
            if(list[i] == target) //check if that item is what you're looking for
            {
                return i; //report finding!
            }
        }
        //if went through ALL the items without finding
        return -1; //wasn't there
    }

    /**
     * Performs a binary search of the list for the target
     * @param the target to look for in the list
     * @return index of first occurrence of target, or -1 if not found
     */
    public int binarySearch(int target)
    {
        int startBound = 0; //first possible location at the beginning
        int endBound = list.length-1; //last possible location at the end

        while(startBound <= endBound) //keep going while more things to check
        {
            int middleIndex = (startBound+endBound)/2; //find the average of the start and end
            if(target == list[middleIndex]) //look at the middle item
            {
                return middleIndex; //report finding
            }
            else if(target < list[middleIndex]) //if the target is less than the middle
            {
                endBound = middleIndex - 1; //move the end goalpost (don't include the middle)
            }
            else //if the target is more than the middle
            {
                startBound = middleIndex + 1; //moves the starting goalpost (don't include the middle)
            }
        }
        return -1; //report never found the target
    }
    
    /** 
     * Gets the String representation of the list being searched
     * @return The string representing
     */
    public String toString()
    {
        String str = ""+list[0];
        for (int i=1; i<list.length; i++)
        {
            str += "," + list[i];
        }
        return "[" + str + "]";
    }
}